<template>
  <div class="table">
    <b-table
      hover
      bordered
      borderless
      :sort-by.sync="sortBy"
      :sort-desc.sync="sortDesc"
      sort-icon-left
      responsive
      :items="items"
      :fields="tableFields"
    >
      <template v-slot:cell(avatar)="data" class="avatar-cell">
        <v-gravatar
          class="avatar"
          :email="data.item.companyEmail"
          default-img="retro"
          :size="80"
        />
      </template>
      <template v-slot:cell(tags)="data">
        {{ getTags(data.item.tags) }}
      </template>
      <template v-slot:cell(startDate)="data">
        {{ formatDate(data.item.startDate) }}
      </template>
      <template v-slot:cell(birthdate)="data">
        {{ formatDate(data.item.birthdate) }}
      </template>
      <template v-slot:cell(actions)="data" class="actions-cell">
        <action-buttons
          :employee="data.item.id"
          :active-tab="activeTab"
          @viewEmployee="onView"
          @editEmployee="onEdit"
          @deactivateEmployee="onDeactivate"
          @activateEmployee="onActivate"
        />
      </template>
    </b-table>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'
import Gravatar from 'vue-gravatar'
import { formatDate } from '../../../utils/index'
import ActionButtons from './ActionButtons.vue'

export default Vue.extend({
  name: 'Table',
  components: { 'v-gravatar': Gravatar, ActionButtons },
  props: {
    tableFields: {
      type: Array as () => any,
      default: () => {}
    },
    items: {
      type: Array,
      default: () => {}
    },
    activeTab: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      sortBy: 'age',
      sortDesc: false
    }
  },
  created() {
    this.tableFields[0] = { key: 'avatar', label: ' ' }
    this.tableFields[3] = { key: 'companyEmail', label: 'Email' }
  },
  methods: {
    formatDate,
    onView(name: string, id: any) {
      this.$emit('viewEmployee', name, id)
    },
    onEdit(name: string, id: any) {
      this.$emit('editEmployee', name, id)
    },
    onDeactivate(id: any) {
      this.$emit('deactivateEmployee', id)
    },
    onActivate(id: any) {
      this.$emit('activateEmployee', id)
    },
    getTags(tags: any) {
      return (this.$parent as any).getTags(tags)
    }
  }
})
</script>

<style>
.table {
  font-size: 14px;
  border-radius: 8px;
}

.table,
thead,
th {
  color: rgb(79, 79, 79);
  background-color: #fff;
}

.table,
tbody,
tr {
  background-color: #f7f7f7;
  border-style: solid;
  border-width: 1px;
  border-color: #f2f2f2;
  border-radius: 0 0 8px 8px;
  font-weight: 500;
}

.table td {
  border-style: solid;
  border-width: 1px;
  border-color: #f2f2f2;
  white-space: nowrap;
  text-overflow: ellipsis;
  padding: 7px 5px;
  overflow: hidden;
  max-width: 100px;
}

.avatar,
img {
  border-radius: 50%;
  border: 1px solid #13bc74;
  width: 35px;
  height: 35px;
  float: right;
  padding: 0;
}
</style>
